﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace tree
{
    public partial class Window : Form
    {
        public Window()
        {
            InitializeComponent();
        }

        private void testMenu_Click(object sender, EventArgs e)
        {
            TreeNode branch = new TreeNode ();
            branch.Text = "root";
            tree.Nodes.Add (branch);

            for (int i = 1; i <= 4; i++)
            {
                TreeNode node = new TreeNode();
                node.Text = "leaf " + i;
                node.BackColor = Color.FromArgb (128, 63*i, 128);
                node.ForeColor = Color.Orange;
                node.ToolTipText = "Listek " + i;
                node.ImageIndex = i;
                node.SelectedImageIndex = 4+i;
                branch.Nodes.Add(node);
            }

            branch.Expand ();
            tree.ShowNodeToolTips = true;
        }

        private void tree_NodeMouseDoubleClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            /*
            try
            {
                pictureBox1.Image = tree.ImageList.Images [e.Node.ImageIndex];
            }
            catch (Exception)
            {
            }
            */
        }

        private void splitContainer2_Panel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void directoryMenu_Click(object sender, EventArgs e)
        {
            tree.ShowNodeToolTips = true;
            showDir (tree.Nodes, "c:\\", 2);
        }

        private void showDir (TreeNodeCollection target, string path, int levels)
        {
            try
            {
                DirectoryInfo info = new DirectoryInfo (path);
                TreeNode branch = new TreeNode();
                branch.Text = info.Name;
                branch.ToolTipText = path;
                branch.Tag = path;
                target.Add (branch);

                if (levels > 1)
                {
                   // using System.IO;
                   DirectoryInfo[] dirs = info.GetDirectories();
                   foreach (DirectoryInfo subdir in dirs)
                       showDir (branch.Nodes, subdir.FullName, levels - 1);
                }
            }
            catch (Exception e)
            {
            }
        }

        private void tree_BeforeExpand(object sender, TreeViewCancelEventArgs e)
        {
            if (e.Node.Nodes.Count == 0)
            {
                string path = (string)e.Node.Tag;
                try
                {
                    DirectoryInfo info = new DirectoryInfo(path);
                    DirectoryInfo[] dirs = info.GetDirectories();
                    foreach (DirectoryInfo subdir in dirs)
                        showDir(e.Node.Nodes, subdir.FullName, 2);
                }
                catch (Exception ex)
                {
                }
            }
            else 
            {
                foreach (TreeNode t in e.Node.Nodes)
                try
                {
                    string path = (string) t.Tag;
                    DirectoryInfo info = new DirectoryInfo(path);
                    DirectoryInfo[] dirs = info.GetDirectories();
                    foreach (DirectoryInfo subdir in dirs)
                        showDir(t.Nodes, subdir.FullName, 1);
                }
                catch (Exception ex)
                {
                }
            }
        }


    }
}
